#include "stm8l.h"
#include "stm8l_gpio.h"
#include "stm8l_clk.h"
#include "stm8l_exti.h"

#define PORT GPIOB

#define LED 	GPIO_Pin_1
#define BTN_LED GPIO_Pin_2

#define BTN 	GPIO_Pin_3

static void delay(uint32_t t)
{
	while(t--);
}

INTERRUPT_HANDLER(IRQ_Handler_EXTI_PIN_3, 11){
	delay(500);
	EXTI_ClearITPendingBit(EXTI_IT_Pin3);
}

uint8_t i, press;

int main( void )
{
	// ---------   GPIO Config ---------------------------

	GPIO_DeInit(PORT);

	GPIO_Init(PORT, (GPIO_Pin_TypeDef)(LED | BTN_LED), GPIO_Mode_Out_PP_Low_Fast);

	GPIO_Init(PORT, BTN, GPIO_Mode_In_FL_IT); // Input floating, no external interrupt

        // ---------- CLK CONFIG -----------------------
        CLK_DeInit();
        CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);

	// ---------- EXTI CONFIG ----------------------
	EXTI_DeInit();
	EXTI_SetPinSensitivity(EXTI_Pin_3,EXTI_Trigger_Falling_Low);
	EXTI_SelectPort(EXTI_Port_B);

	enableInterrupts();

	i=0;
	for(;;)
  	{
    		delay(1000); i++;

		if (i > 50)
		{
			GPIO_ToggleBits(PORT, BTN_LED);
			i=0;
		}
  	}
}
