#include "stm8s.h"
#include "stm8s_gpio.h"
#include "stm8s_clk.h"
#include "stm8s_exti.h"

#define LED_PORT GPIOB
#define LED GPIO_PIN_5

#define BTN_PORT GPIOD
#define BTN GPIO_PIN_2


#define TLI_BTN_PORT GPIOC
#define TLI_BTN GPIO_PIN_3


static void delay(uint32_t t)
{
	while(t--);
}


INTERRUPT_HANDLER(IRQ_Handler_TLI, 0)
{
       GPIO_WriteReverse(LED_PORT, LED);
}

INTERRUPT_HANDLER(IRQ_Handler_EXTI_PORT_D, 6)
{

	delay(100);
}

uint8_t i;

int main( void )
{

	// ----------- GPIO CONFIG -------------------
	GPIO_DeInit(LED_PORT);
	GPIO_Init(LED_PORT, LED, GPIO_MODE_OUT_PP_LOW_FAST);

	GPIO_DeInit(BTN_PORT);
	GPIO_Init(BTN_PORT, BTN, GPIO_MODE_IN_FL_IT); // Input floating, with interrupt

	GPIO_DeInit(TLI_BTN_PORT);
	GPIO_Init(TLI_BTN_PORT, TLI_BTN, GPIO_MODE_IN_FL_IT); // Input floating, with interrupt


	// ----------- EXTI CONFIG ---------------------
	EXTI_DeInit();
	EXTI_SetExtIntSensitivity(EXTI_PORT_GPIOD, EXTI_SENSITIVITY_FALL_LOW);

	EXTI_SetTLISensitivity(EXTI_TLISENSITIVITY_RISE_ONLY);

	// ---------- CLK CONFIG -----------------------
	CLK_DeInit();

    	CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
	CLK_SYSCLKConfig(CLK_PRESCALER_HSIDIV1); // set 16 MHz for CPU

	enableInterrupts();

	i=0;
	for(;;)
  	{
    		delay(1000); i++;

		if (i > 50)
		{
			GPIO_WriteReverse(LED_PORT, LED);
			i=0;

		}
  	}
}
